#include <sys/types.h>
#include <dirent.h>
#include <iostream>
#include <algorithm>
#include <fstream>
#include <cstdlib>
#include <cstring>
#include "util.h"
using namespace std;

char* bstrstr(const char* str1,const char* str2,int size)
{
    for(int i=0;i<size;++i)
    {
        if(str1[i]!=str2[0])
            continue;
        char* d=0;
        if((d=(char*)strstr(&str1[i],str2))!=0 && d==&str1[i])
            return d;
    }
    return 0;
}

vector<string>* getdir(const char* path)
{
    DIR* dp;
    dirent* dirp;
    if((dp=opendir(path))==NULL)
    {
        cerr << "Error opening directory \"" << path <<"\"\n";
        exit(1);
    }

    vector<string>* files=new vector<string>;
    while((dirp=readdir(dp))!=NULL)
    {
        if(!strcmp(dirp->d_name,".")||!strcmp(dirp->d_name,".."))
            continue;
        files->push_back(string(dirp->d_name));
    }

    closedir(dp);
    // Resources should be sorted by ID when written to package, so do sort direntries by name now
    sort(files->begin(),files->end());
    return files;
}

char* readFile(const char* filename,int& size)
{
    ifstream file;
    file.open(filename,ios::in|ios::binary|ios::ate);
    size=file.tellg();
    if(size<0)
    {
        cerr << "Couldn't open file \"" << filename << "\"\n";
        exit(3);
    }
    char* data=new char[size];
    file.seekg(0,ios::beg);
    file.read(data,size);
    file.close();
    return data;
}


